<?php
/*
Plugin Name: SILO Bot
Plugin URI: http://seointerlink.org
Description: Interlinks the whole site for SEO.
Version: 1.0
License: GPLv2
Author: KME Byrne And  Craig Mako
Author URI: http://seointerlink.org
*/
//Adding css and js in admin 
function silo_bot_add_admin_css_js() {

	wp_enqueue_style( 'silo_bot-farbtasticcss', plugins_url( '/css/farbtastic.css' , __FILE__ ) );
	wp_deregister_script('jquery');
	wp_enqueue_script( 'silo_bot-jqueryjs', plugins_url( '/js/jquery.js' , __FILE__ ) );
	wp_enqueue_script( 'silo_bot-farbtasticjs', plugins_url( '/js/farbtastic.js' , __FILE__ ) );
}
//hook for admin css and js
add_action( 'admin_enqueue_scripts', 'silo_bot_add_admin_css_js' );
//hook for "all related links
add_filter('the_content', 'silo_bot_add_post_content');
function silo_bot_add_post_content($content) {
    $m_keyword = get_option('SiloBot_silo_bot_m_keyword');
    $m_k_url = get_option('SiloBot_silo_bot_m_k_url');
    
    $s1_keyword = get_option('SiloBot_silo_bot_s1_keyword');
    $s1_k_url = get_option('SiloBot_silo_bot_s1_k_url');
    
    $s2_keyword = get_option('SiloBot_silo_bot_s2_keyword');
    $s2_k_url = get_option('SiloBot_silo_bot_s2_k_url');
    
    $aff_keyword = get_option('SiloBot_silo_bot_aff_keyword');
    $aff_k_url = get_option('SiloBot_silo_bot_aff_k_url');
	$re_heading_text = get_option('SiloBot_silo_bot_re_heading_text');
	$re_heading_color = get_option('SiloBot_silo_bot_re_heading_color');
	$link_color = get_option('SiloBot_silo_bot_link_color');
	$enable_on = get_option('SiloBot_silo_bot_enable_on');
    
    if($enable_on['text_string'] == get_post_type() || $enable_on['text_string'] == 'both'){
	/*if(!empty($content)){
	$content.=$content;
	}*/
	$content .="<style type='text/css'>
				#seolinksdiv h3{
				color:".$re_heading_color['text_string'].";
				}
				#seolinksdiv ul li a{
				color:".$link_color['text_string'].";
				}
				</style>";
	 $content .= '<div id="seolinksdiv">';  
	if($re_heading_text['text_string']!='' && !is_front_page()) {
	   $content .='<h3>' .$re_heading_text['text_string']. '</h3><ul>';
	}else {
	   $content .= '<h3>Recommended Reading</h3><ul>';
	}
	if($m_keyword['text_string']!='' && !is_front_page()) {	$content .= '<li><a href="' . $m_k_url['text_string'] . '">' . $m_keyword['text_string'] . '</a></li>'; }
		
		if($s1_keyword['text_string']!='' && get_post_type()!='post' && !is_page() || is_front_page()) {	$content .= '<li><a href="' . $s1_k_url['text_string'] . '">' . $s1_keyword['text_string'] . '</a></li>'; }
		
		if($s2_keyword['text_string']!='' && get_post_type()!='post' && !is_page() || is_front_page()) {	$content .= '<li><a href="' . $s2_k_url['text_string'] . '">' . $s2_keyword['text_string'] . '</a></li>'; }
		$content .= silo_bot_related_posts();
		if($aff_keyword['text_string']!='') {	$content .= '<li><a href="' . $aff_k_url['text_string'] . '">' . $aff_keyword['text_string'] . '</a></li>'; }
	$content .= '</ul></div>';
	}
    return $content;
}
function silo_bot_related_posts(){

$orig_post = $post;
global $post;

$cat_or_tag= get_option('SiloBot_silo_bot_cat_tag');
$cat_tag_no = get_option('SiloBot_silo_bot_related_count');

if($cat_or_tag['text_string']=='tags'){

$tags = wp_get_post_tags($post->ID);
if ($tags) {
$tag_ids = array();
foreach($tags as $individual_tag) $tag_ids[] = $individual_tag->term_id;
$args=array(
'tag__in' => $tag_ids,
'post__not_in' => array($post->ID),
'posts_per_page'=>$cat_tag_no['text_string'], // Number of related posts that will be shown.
'caller_get_posts'=> 1
);
}
}
else{
$categories = get_the_category($post->ID);
if ($categories) {
$category_ids = array();
foreach($categories as $individual_category) $category_ids[] = $individual_category->term_id;

$args=array(
'category__in' => $category_ids,
'post__not_in' => array($post->ID),
'posts_per_page'=> $cat_tag_no['text_string'], // Number of related posts that will be shown.
'caller_get_posts'=> 1
);
}
}
$my_query = new wp_query( $args );
if( $my_query->have_posts() ) {
$related_posts = '';
while( $my_query->have_posts() ) {
$my_query->the_post();
$related_posts .= '<li><a href="' . get_permalink() . '" rel="bookmark" title="' . get_the_title() . '">' . get_the_title() . '</a></li>';
}

}

$post = $orig_post;
wp_reset_query();

return $related_posts;

}
//  * Full details of how to use Settings see here: http://codex.wordpress.org/Settings_API
 
class silo_bot_settings_config {
 
// MAIN CONFIGURATION SETTINGS
 
var $group = "SiloBot"; // defines setting groups (should be bespoke to your settings)
var $page_name = "silo_bot"; // defines which pages settings will appear on. Either bespoke or media/discussion/reading etc
 
//  DISPLAY SETTINGS
//  (only used if bespoke page_name)
 
var $title = "SILO Bot";  // page title that is displayed
var $intro_text = "This allows you to configure the links to show under post content"; // text below title
var $nav_title = "SILO Bot"; // how page is listed on left-hand Settings panel
 
//  SECTIONS
//  Each section should be own array within $sections.
//  Should contatin title, description and fields, which should be array of all fields.
//  Fields array should contain:
//  * label: the displayed label of the field. Required.
//  * description: the field description, displayed under the field. Optional
//  * suffix: displays right of the field entry. Optional
//  * default_value: default value if field is empty. Optional
//  * dropdown: allows you to offer dropdown functionality on field. Value is array listed below. Optional
//  * function: will call function other than default text field to display options. Option
//  * callback: will run callback function to validate field. Optional
//  * All variables are sent to display function as array, therefore other variables can be added if needed for display purposes
 
var $sections = array(
    'silo_bot' => array(
        'title' => "Main Keyword & URL of the Site ",
        'description' => "This would be your Site URL and keyword",
         'fields' => array (
              'silo_bot_m_keyword' => array (
              'label' => "Main Keyword",
              'description' => "Main Keyword for SEO",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_bot_m_k_url' => array (
              'label' => "Main Keyword URL",
              'description' => "Link for the same",
              'length' => "3",
              'default_value' => ""
              )
          )
        ),
        'silo_bot2' => array(
        'title' => "Secondary Keywords & URL'S",
        'description' => "Links & Keywords to the second most important posts on your site.",
         'fields' => array (
          'silo_bot_s1_keyword' => array (
              'label' => "Secondary Keyword (1)",
              'description' => "Secondry Keyword 1 for SEO",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_bot_s1_k_url' => array (
              'label' => "Secondary URL (1)",
              'description' => "Link for the same",
              'length' => "3",
              'default_value' => ""
              ),
           
           'silo_bot_s2_keyword' => array (
              'label' => "Secondary Keyword (2)",
              'description' => "Secondry Keyword 2 for SEO",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_bot_s2_k_url' => array (
              'label' => "Secondary URL (2)",
              'description' => "Link for the same",
              'length' => "3",
              'default_value' => ""
              )
           )
          ),
         'silo_bot3' => array(
         'title' => "Other Settings",
         'fields' => array (
          'silo_bot_enable_on' => array(
              'label' => "Enable on Posts or Pages or Both",
              'description' => "Select from dropdown",
              'dropdown' => "dd_enable",
              'default_value' => "posts"),
          'silo_bot_cat_tag' => array(
              'label' => "Related Posts Links",
              'description' => "Based on Category or Tags",
              'dropdown' => "dd_cat_tag",
              'default_value' => "category"),
            'silo_bot_related_count' => array(
              'label' => "Related Posts Count",
              'description' => "Choose the Number of related posts",
              'dropdown' => "dd_related",
              'default_value' => "2"),
           'silo_bot_aff_keyword' => array (
              'label' => "Affiliate Keyword",
              'description' => "Optional",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_bot_aff_k_url' => array (
              'label' => "Affiliate Keyword URL",
              'description' => "Optional",
              'length' => "3",
              'default_value' => ""
              ),
		 )
      ),
	  'silo_bot4' => array(
         'title' => "additional settings",
         'fields' => array (
          'silo_bot_re_heading_text' => array (
		  'label' => "Change Recommended Reading Heading Text:",
		  'description' => "Choose Heading Text",
		  'length' => "3",
		  'default_value' => "Recommended Reading"
		  ),
		  'silo_bot_re_heading_color' => array (
		  'label' => "Change Recommended Reading Heading Text color:",
		  'description' => "Choose Heading Text color<br/><div style='width: 567px;' id='colorpicker1'></div>",
		  'length' => "3",
		  'default_value' => "#000000"
		  ),
		  'silo_bot_link_color' => array (
		  'label' => "Change link color:",
		  'description' => "Choose Link color<br/><div style='width: 567px;' id='colorpicker2'></div>",
		  'length' => "3",
		  'default_value' => "#000000"
		  ) 
		)
	  )
    );
 // DROPDOWN OPTIONS
 // For drop down choices.  Each set of choices should be unique array
 // Use key => value to indicate name => display name
 // For default_value in options field use key, not value
 // You can have multiple instances of the same dropdown options
 
var $dropdown_options = array (
    'dd_related' => array (
        '0' => '0',
        '1' => "1",
        '2' => "2",
        '3' => "3",
        '4' => "4",
        '5' => "5",
        '6' => "6"
        ),
    'dd_cat_tag' => array (
        'category' => "Category",
        'tags' => "Tags"
        ),
    'dd_enable' => array (
        'post' => "Posts",
        'page' => "Pages",
        'both' => "Both",
        )
	);
//  end class
};
require_once('seo_settings.php');
$silo_bot_settings_init = new silo_bot_settings('silo_bot_settings_config');
function add_category_box_on_page(){
    //add meta box
    add_meta_box('categorydiv', __('Categories'), 'post_categories_meta_box', 'page', 'side', 'low');
    add_meta_box('tagsdiv-post_tag', __('Page Tags'), 'post_tags_meta_box', 'page', 'side', 'low');
    add_action('save_post', 'booster_page_cats_tags_save_postdata');
}
 
add_action('admin_menu', 'add_category_box_on_page');
function booster_page_cats_tags_save_postdata( $post_id ) {
 
    $seob_post_type = $_POST['post_type'];
 
    // verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
    // to do anything
    if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ){
 
    }else{
        // Check permissions
        if ( 'page' == $seob_post_type ) {
            if ( current_user_can( 'edit_page', $post_id ) ){
 
                $seob_post_cats = array();
 
                foreach($_REQUEST['post_category'] as $key=>$val){
                    $seob_post_cats[] = $val;
                }
                wp_set_post_categories( $post_id, $seob_post_cats );
            }
        }
    }
}?>