<?php

class DanvaaCustomWidget extends WP_Widget {

	function __construct() {
		parent::WP_Widget(false, $name='WP Resurrector');
	}
	
	function filter_where( $where = '' ) {
		$where .= " AND post_date > '" . date('Y-m-d', strtotime('-' . $GLOBALS["post_since"] . ' ' . $GLOBALS["post_since_type"] )) . "'";
		return $where;
	}
	
	function widget($args, $instance) {
		global $post;
		
		$post_old = $post;		
		extract( $args );		
		if( !$instance["title"] ) $instance["title"] = "WP Resurrector";
		
		$qry = ""; $showPosts = false;
		$qry .= "showposts=" . $instance["number_of_posts"];		
		
		if( isset( $instance['posts_in_category_flag'] ) ) {
			if( !empty( $instance["posts_in_category"] ) ) {
				$posts_in_category = implode("," , $instance["posts_in_category"]);
				$qry .= "&cat=" . $posts_in_category;
				$showPosts = true;
			}
		}
		
		if( isset( $instance['posts_in_tag_flag'] ) ) {
			if( !empty( $instance["posts_in_tag"] ) ) {
				$posts_in_tag = implode("," , $instance["posts_in_tag"]);
				$qry .= "&tag_id=" . $posts_in_tag;
				$showPosts = true;
			}
		}
		
		$qry .= "&orderby=date&order=" . $instance["sort_by"];
		
		$GLOBALS['post_since'] = $instance["post_since"];
		$GLOBALS['post_since_type'] = $instance["post_since_type"];		

		add_filter( 'posts_where', array(&$this, 'filter_where') );
		
		$post_lists = new WP_Query( $qry );
		
		remove_filter( 'posts_where', array(&$this, 'filter_where') );
				
		echo $before_widget;
		echo $before_title . $instance["title"] . $after_title;		
		
		echo "<ul>\n";
		if ( $post_lists->post_count > 0) {
			while ( $post_lists->have_posts() ) { $post_lists->the_post(); do_action('DV_post_submit', get_the_id() ); ?>
				<li class="cat-post-item">
					<a class="post-title" href="<?php the_permalink(); ?>" rel="bookmark" title="Permanent link to <?php the_title_attribute(); ?>">
						<?php 
							$title = get_the_title(); //the_title();
							if( strlen( $title ) > 45 ) {
							  	echo substr($title, 0, 45). '...';
							} else echo $title;				
						?>
					</a><?php /*?> on <span class="post-date"><?php the_time(get_option('date_format')); ?></span><?php */?>									
				</li>
				<?php
			}
		} else {
			echo "No posts found";	
		}		
		echo "</ul>\n";
		
		echo $after_widget;	
		
		$post = $post_old;
	}
	
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	
	function form($instance) {
		if( empty( $instance ) ) $initialStage = true; else $initialStage = false;
		if( !isset( $instance["posts_in_category"] ) ) $instance["posts_in_category"] = array();
		if( !isset( $instance["posts_in_tag"] ) ) $instance["posts_in_tag"] = array();
		?>
		<?php if( !$initialStage ) { ?>
		<script type="text/javascript">
			jQuery(document).ready(function() {
				<?php if( !isset( $instance['posts_in_category_flag'] ) ) { ?>
					jQuery("#<?php echo $this->get_field_id("posts_in_category"); ?>").attr('disabled', true);
					jQuery("#<?php echo $this->get_field_id("posts_in_category"); ?>").attr('selectedIndex', '-1').children('option:selected').removeAttr('selected');
				<?php } ?>
				<?php if( !isset( $instance['posts_in_tag_flag'] ) ) { ?>
					jQuery("#<?php echo $this->get_field_id("posts_in_tag"); ?>").attr('disabled', true);
					jQuery("#<?php echo $this->get_field_id("posts_in_tag"); ?>").attr('selectedIndex', '-1').children('option:selected').removeAttr('selected');
				<?php } ?>
				
				jQuery("#<?php echo $this->get_field_id("posts_in_category_flag"); ?>").click(function() {
					if( jQuery("#<?php echo $this->get_field_id("posts_in_category_flag"); ?>").is(':checked') ) {
						jQuery("#<?php echo $this->get_field_id("posts_in_category"); ?>").attr('disabled', false);
					} else {
						jQuery("#<?php echo $this->get_field_id("posts_in_category"); ?>").attr('disabled', true);
						jQuery("#<?php echo $this->get_field_id("posts_in_category"); ?>").attr('selectedIndex', '-1').children('option:selected').removeAttr('selected');
					}
				});
				jQuery("#<?php echo $this->get_field_id("posts_in_tag_flag"); ?>").click(function() {
					if( jQuery("#<?php echo $this->get_field_id("posts_in_tag_flag"); ?>").is(':checked') ) {
						jQuery("#<?php echo $this->get_field_id("posts_in_tag"); ?>").attr('disabled', false);
					} else {
						jQuery("#<?php echo $this->get_field_id("posts_in_tag"); ?>").attr('disabled', true);
						jQuery("#<?php echo $this->get_field_id("posts_in_tag"); ?>").attr('selectedIndex', '-1').children('option:selected').removeAttr('selected');
					}
				});
			});
		</script>
		<?php } ?>
		<p>
			<label for="<?php echo $this->get_field_id("title"); ?>">
				<?php _e( 'Title' ); ?>
				<input class="widefat" id="<?php echo $this->get_field_id("title"); ?>" name="<?php echo $this->get_field_name("title"); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id("post_since"); ?>">
				<?php _e( 'Show posts of last' ); ?>
				<select id="<?php echo $this->get_field_id("post_since"); ?>" name="<?php echo $this->get_field_name("post_since"); ?>">
					<?php for( $i = 1; $i <= 31; $i++ ) { ?>
					<option value="<?php echo $i; ?>" <?php selected( $instance["post_since"], $i ); ?>><?php echo $i; ?></option>
					<?php } ?>				
				</select>			
			</label>
			<label for="<?php echo $this->get_field_id("post_since_type"); ?>">
				<select id="<?php echo $this->get_field_id("post_since_type"); ?>" name="<?php echo $this->get_field_name("post_since_type"); ?>">
					<option value="days" <?php selected( $instance["post_since_type"], 'days' ); ?>>Days</option>
					<option value="month" <?php selected( $instance["post_since_type"], 'month' ); ?>>Months</option>
				</select>
			</label>
		</p>
		<p><?php _e( 'Posts in' ); ?></p>
		<p>
			<label for="<?php echo $this->get_field_id("posts_in_category_flag"); ?>" style="vertical-align:top;clear:both;">
				<?php if( isset( $instance['posts_in_category_flag'] ) ) $category_flag = 'checked="checked"'; else $category_flag = ''; ?>
				<input type="checkbox" id="<?php echo $this->get_field_id("posts_in_category_flag"); ?>" name="<?php echo $this->get_field_name("posts_in_category_flag"); ?>" <?php echo $category_flag; ?> />
				<?php _e( 'Categories' ); ?>
			</label>
			<label for="<?php echo $this->get_field_id("posts_in_category"); ?>">
				<?php $categories = get_categories( array( 'echo' => 0, 'hide_empty' => 0, 'name' => $this->get_field_name("posts_in_category"), 'selected' => $instance["posts_in_category"] ) );	?>
				<select id="<?php echo $this->get_field_id("posts_in_category"); ?>" name="<?php echo $this->get_field_name("posts_in_category"); ?>[]" multiple="multiple" style="width:100%;">
				<?php foreach( $categories as $category ) { ?>
					<option value="<?php echo $category->term_id; ?>" <?php if( in_array($category->term_id, $instance["posts_in_category"] ) ) echo "selected"; ?>><?php echo $category->name; ?></option>
				<?php } ?>	
				</select>			
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id("posts_in_tag_flag"); ?>" style="vertical-align:top;clear:both;">
				<?php if( isset( $instance['posts_in_tag_flag'] ) ) $tag_flag = 'checked="checked"'; else $tag_flag = ''; ?>						
				<input type="checkbox" id="<?php echo $this->get_field_id("posts_in_tag_flag"); ?>" name="<?php echo $this->get_field_name("posts_in_tag_flag"); ?>" <?php echo $tag_flag; ?> />
				<?php _e( 'Tags' ); ?>
			</label>
			<label for="<?php echo $this->get_field_id("posts_in_tag"); ?>">
				<?php $tags = get_categories( array( 'taxonomy' => 'post_tag', 'echo' => 0, 'hide_empty' => 0, 'name' => $this->get_field_name("posts_in_tag"), 'selected' => $instance["posts_in_tag"] ) );	?>
				<select id="<?php echo $this->get_field_id("posts_in_tag"); ?>" name="<?php echo $this->get_field_name("posts_in_tag"); ?>[]" multiple="multiple" style="width:100%;">
				<?php foreach( $tags as $tag ) { ?>
					<option value="<?php echo $tag->term_id; ?>" <?php if( in_array($tag->term_id, $instance["posts_in_tag"] ) ) echo "selected"; ?>><?php echo $tag->name; ?></option>
				<?php } ?>	
				</select>			
			</label>
		</p>
		<p><label for="<?php echo $this->get_field_id("number_of_posts"); ?>">
			<?php _e('Number of posts to show'); ?>
			<?php /*?><input style="text-align: center;" id="<?php echo $this->get_field_id("number_of_posts"); ?>" name="<?php echo $this->get_field_name("number_of_posts"); ?>" type="text" value="<?php echo absint($instance["number_of_posts"]); ?>" size='3' /><? */?>
			<select id="<?php echo $this->get_field_id("number_of_posts"); ?>" name="<?php echo $this->get_field_name("number_of_posts"); ?>">
				<option value="5"<?php selected( $instance["number_of_posts"], "5" ); ?>>5</option>
				<option value="10"<?php selected( $instance["number_of_posts"], "10" ); ?>>10</option>
				<option value="15"<?php selected( $instance["number_of_posts"], "15" ); ?>>15</option>
				<option value="20"<?php selected( $instance["number_of_posts"], "20" ); ?>>20</option>
				<option value="25"<?php selected( $instance["number_of_posts"], "25" ); ?>>25</option>
			</select>
		</label></p>
	    <p><label for="<?php echo $this->get_field_id("sort_by"); ?>">
			<?php _e('Sort by'); ?>
	        <select id="<?php echo $this->get_field_id("sort_by"); ?>" name="<?php echo $this->get_field_name("sort_by"); ?>">
				<option value="ASC"<?php selected( $instance["sort_by"], "ASC" ); ?>>Oldest to Newest</option>
				<option value="DESC"<?php selected( $instance["sort_by"], "DESC" ); ?>>Newest to Oldest</option>
			</select>
		</label></p>
	<?php	
	}
}
add_action( 'widgets_init', create_function( '', 'return register_widget("DanvaaCustomWidget");' ) );
?>